<?php
  ########################################################################
  # RT Download Counter 2.4 • 17/12/2022 © Alessandro Marinuzzi [Alecos] #
  ########################################################################
  include($_SERVER["DOCUMENT_ROOT"] . "/php/config.php");
  include($_SERVER["DOCUMENT_ROOT"] . "/php/resume_download.php");
  // Check if HTTPS
  function check_protocol() {
    $isSecure = false;
    if (isset($_SERVER['HTTPS']) && strtolower($_SERVER['HTTPS']) == 'on') {
      $isSecure = true;
    } elseif (!empty($_SERVER['HTTP_X_FORWARDED_PROTO']) && strtolower($_SERVER['HTTP_X_FORWARDED_PROTO']) == 'https' || !empty($_SERVER['HTTP_X_FORWARDED_SSL']) && strtolower($_SERVER['HTTP_X_FORWARDED_SSL']) == 'on') {
      $isSecure = true;
    }
    return $isSecure;
  }
  // Where the files are
  $downloads_folder = $_SERVER['DOCUMENT_ROOT'] . '/files/';
  $hit_downloads_db = $_SERVER['DOCUMENT_ROOT'] . "/files/counter/download.sqlite";
  // Has a file name been passed?
  if (!empty($_GET['file'])) {
    // Protect from people getting other files
    $file = basename($_GET['file']);
    $file = htmlspecialchars($file, ENT_QUOTES | ENT_HTML401, 'UTF-8');
    $file = str_replace("\0", "", $file);
    $type = array("zip", "rar");
    $exts = strtolower(substr(strrchr($file, "."), 1));
    if (!in_array($exts, $type)) {
      header("HTTP/1.1 403 Forbidden");
      exit('File not allowed!');
    } else {
      // Does the file exist?
      if (file_exists($downloads_folder . $file)) {
        // Update counter - add if don't exist
        try {
          if (!file_exists($hit_downloads_db)) {
            $downloaddb = new PDO("sqlite:" . $hit_downloads_db);
            $downloaddb->exec('CREATE TABLE download(file VARCHAR(255) PRIMARY KEY, count INTEGER)');
          } else {
            $downloaddb = new PDO("sqlite:" . $hit_downloads_db);
          }
        }
        catch (PDOException $e) {
          die($e->getMessage());
        }
        $safefile = md5($file);
        $selectdb = $downloaddb->prepare('SELECT count FROM download WHERE file = :file');
        $selectdb->execute(['file' => $safefile]);
        $downloaddbrecord = $selectdb->fetchAll();
        if (sizeof($downloaddbrecord) != 0) {
          // Increment counter if is not used a Download Manager
          if (!isset($_SERVER['HTTP_RANGE'])) {
            $count = ++$downloaddbrecord[0]['count'];
            $updatedb = $downloaddb->prepare('UPDATE download SET count = :count WHERE file = :file');
            $updatedb->execute(['count' => $count, 'file' => $safefile]);
          } else {
            // Don't increment counter if is used a Download Manager
            $count = $downloaddbrecord[0]['count'];
            $updatedb = $downloaddb->prepare('UPDATE download SET count = :count WHERE file = :file');
            $updatedb->execute(['count' => $count, 'file' => $safefile]);
          }
        } else {
          $insertdb = $downloaddb->prepare('INSERT INTO download(file, count) VALUES (:file, 1)');
          $insertdb->execute(['file' => $safefile]);
        }
        $downloaddb = null;
        // Set the Download Resume
        @set_time_limit(0);
        $download = new ResumeDownload($downloads_folder . $file);
        $download->process();
        exit;
      } else {
        header("HTTP/1.1 404 Not Found");
        exit('File not found!');
      }
    }
  } else {
    // No file to download?
    $protocol = check_protocol() ? 'https://' : 'http://';
    $absolute = $protocol . rtrim($_SERVER['HTTP_HOST'], '/\\');
    header("Location: $absolute/");
    exit();
  }
?>